﻿package com.josephlabrecque.actors {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	
	public class Obstacle extends MovieClip {
		
		private var _speed:int;
		
		public var obstacleSkins:MovieClip;
		
		public function Obstacle() {
			this.addEventListener(Event.ADDED_TO_STAGE, addedToStage);
			this.addEventListener(Event.REMOVED_FROM_STAGE, removedFromStage);
			var skinCount:int = obstacleSkins.totalFrames+1;
			var skinIndex:int = 1 + (skinCount - 1) * Math.random();
			obstacleSkins.gotoAndStop(skinIndex);
		}
		
		private function addedToStage(e:Event):void {
			this.removeEventListener(Event.ADDED_TO_STAGE, addedToStage);
			this.addEventListener(Event.ENTER_FRAME, performMovement);
			
			_speed = 2 + (9 - 2) * Math.random();
			this.width = 10 + (60 - 10) * Math.random();
			this.height = this.width;
			resetPosition();
		}
		
		private function removedFromStage(e:Event):void {
			this.removeEventListener(Event.ENTER_FRAME, performMovement);
			this.removeEventListener(Event.REMOVED_FROM_STAGE, removedFromStage);
		}
		
		private function performMovement(e:Event):void {
			this.y += _speed;
			this.rotation += _speed/2;
			if(this.y > stage.stageHeight + 100){
				resetPosition();
			}
		}
		
		public function explode():void {
			resetPosition();
		}
		
		private function resetPosition():void {
			this.x = 0 + (stage.stageWidth - 0) * Math.random();
			this.y = -400 + (-100 - -400) * Math.random();
		}
		
	}
	
}
